/*

snowflake drawing

*/

sketch.default2d();
var targx = [0.0, 0.0, 0.0, 0.0,   0.0, 0.0, 0.0, 0.0,  0.0, 0.0, 0.0, 0.0 ];
var targy = [0.0, 0.0, 0.0, 0.0,   0.0, 0.0, 0.0, 0.0,  0.0, 0.0, 0.0, 0.0 ];
var curx = [0.0, 0.0, 0.0, 0.0,   0.0, 0.0, 0.0, 0.0,  0.0, 0.0, 0.0, 0.0 ];
var cury = [0.0, 0.0, 0.0, 0.0,   0.0, 0.0, 0.0, 0.0,  0.0, 0.0, 0.0, 0.0 ];
// make sure to trigger the first "init" in draw()
var incrx = [1.0, 1.0, 1.0, 1.0,  1.0, 1.0, 1.0, 1.0,  1.0, 1.0, 1.0, 1.0 ];
var incry = [1.0, 1.0, 1.0, 1.0,  1.0, 1.0, 1.0, 1.0,  1.0, 1.0, 1.0, 1.0 ];
var incmult = 0.05;
var color1 = [ 1.0, 1.0, 1.0 ];
var color2 = [ 1.0, 1.0, 1.0 ];
var width1, width2;

init();

function init()
{
	with (sketch) {
		// erase background
		glclearcolor(Math.random()*0.1+0.8, Math.random()*0.1+0.8, 1.0, 1.0);
		glclear();
	}
}

function draw()
{
	var rho, theta;
	var i;

	for (i = 0; i < 12; i++) {
		curx[i] = curx[i] + incrx[i];
		cury[i] = cury[i] + incry[i];
	}

	// vertical axis
	if (curx[0] > targx[0]) {
		color1[0] = Math.random()*0.2+0.8;
		color1[1] = Math.random()*0.2+0.8;
		color1[2] = Math.random()*0.2+0.8;
		width1 = Math.random()*10 + 1;

		theta = (0.5*Math.PI) - (0.083*2.0*Math.PI*Math.random());
		rho = Math.random();

		targx[0] = rho*Math.cos(theta);
		targy[0] = rho*Math.sin(theta);
		targx[1] = -targx[0];
		targy[1] = targy[0];
		targx[2] = targx[0];
		targy[2] = -targy[0];
		targx[3] = -targx[0];
		targy[3] = -targy[0];
		for (i = 0; i < 4; i++) {
			curx[i] = 0.0;
			cury[i] = 0.0;
		}
		incrx[0] = (targx[0] - curx[0]) * incmult;
		incry[0] = (targy[0] - cury[0]) * incmult;
		incrx[1] = -incrx[0];
		incry[1] = incry[0];
		incrx[2] = incrx[0];
		incry[2] = -incry[0];
		incrx[3] = -incrx[0];
		incry[3] = -incry[0];

		if (incrx[0] == 0.0) incrx[0] = 1.0; // just in case...
	}

	// side axes
	if (curx[4] > targx[4]) {
		color2[0] = Math.random()*0.2+0.8;
		color2[1] = Math.random()*0.2+0.8;
		color2[2] = Math.random()*0.2+0.8;
		width2 = Math.random()*10 + 1;

		theta = 0.083*2.0*Math.PI*Math.random();
		rho = Math.random();

		targx[4] = rho*Math.cos(theta);
		targy[4] = rho*Math.sin(theta);
		targx[5] = rho*Math.cos(theta + (0.083*2.0*Math.PI));
		targy[5] = rho*Math.sin(theta + (0.083*2.0*Math.PI));
		targx[6] = -targx[4];
		targy[6] = -targy[4];
		targx[7] = -targx[5];
		targy[7] = -targy[5];
		targx[8] = -targx[4];
		targy[8] = targy[4];
		targx[9] = -targx[5];
		targy[9] = targy[5];
		targx[10] = targx[4];
		targy[10] = -targy[4];
		targx[11] = targx[5];
		targy[11] = -targy[5];

		for (i = 4; i < 12; i++) {
			curx[i] = 0.0;
			cury[i] = 0.0;
		}
		incrx[4] = (targx[4] - curx[4]) * incmult;
		incry[4] = (targy[4] - cury[4]) * incmult;
		incrx[5] = (targx[5] - curx[5]) * incmult;
		incry[5] = (targy[5] - cury[5]) * incmult;
		incrx[6] = -incrx[4];
		incry[6] = -incry[4];
		incrx[7] = -incrx[5];
		incry[7] = -incry[5];
		incrx[8] = -incrx[4];
		incry[8] = incry[4]
		incrx[9] = -incrx[5];
		incry[9] = incry[5];
		incrx[10] = incrx[4];
		incry[10] = -incry[4];
		incrx[11] = incrx[5];
		incry[11] = -incry[5];

		if (incrx[4] == 0.0) incrx[4] = 1.0; // just in case...
	}


	with (sketch) {
		for (i = 0; i < 12; i++) {
			if (i == 0) {
				glcolor(color1[0], color1[1], color1[2], 1.0);
				gllinewidth(width1);
			} else if (i == 4) {
				glcolor(color2[0], color2[1], color2[2], 1.0);
				gllinewidth(width2);
			}
			moveto(0,0);
			lineto(curx[i], cury[i]);
		}
	}
}

function bang()
{
	draw();
	refresh();
}

